<?php
/*
 * edit.php - allows web-based editing of short file descriptions
 * that may appear in the index or view page.
 *
 * the page is trivially password-protected.  edit the entries in the
 * following customization section before use.
 *
 * part of the gallery six package: http://muted.org/gallerysix
 *
 * Copyright (C) 2001  seth ladygo
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: edit.php,v 1.12 2004/12/28 02:59:28 alx Exp $
 */

// CUSTOMIZATION SECTION

// a username and password to protect against unauthorized editing.
// change this to something hard to guess :)
$username = "change";
$password = "me";

// END OF CUSTOMIZATION SECTION

// possible names for the index page.
$indexpages = array("index.php", "index.php3");

$thisdir = dirname(getenv("SCRIPT_FILENAME"));

do {
	$val = current($indexpages);
	if (is_file("$thisdir/$val")) {
		$indexpage = $val;
		break;
	}
} while (next($indexpages));

// load in config info from the index page.
include("$indexpage");


// for the crypt function.  ideally this would be more secure.
$salt1 = "-x";
$salt2 = "m5";

$cookie_name = "g6_login";
$cookie_val = crypt($username, $salt1) . crypt($password, $salt2);
$current_cookie = isset($_COOKIE[$cookie_name]) ? $_COOKIE[$cookie_name] : null;

$login_ok = false;
$failed_login = false;
$error = NULL;

$login = isset($_POST["login"]) ? $_POST["login"] : null;
$user = isset($_POST["form_user"]) ? $_POST["form_user"] : null;
$pass = isset($_POST["form_pass"]) ? $_POST["form_pass"] : null;
$do_blurbs = isset($_POST["process_blurbs"]) ? $_POST["process_blurbs"] : null;

// what state are we in?  default to login screen.
if ($current_cookie == $cookie_val) {
	// already logged in, cookie is set
	$login_ok = true;
} elseif ($user == $username && $pass == $password) {
	// just logging in
	setcookie($cookie_name, $cookie_val, time() + 3600, $base_loc);
	$login_ok = true;
} else if ($user != "" || $pass != "") {
	// failed login attempt
	$failed_login = true;
}

if ($login_ok && $do_blurbs) {
	// process form submissions
	while (list($var, $value) = each($_POST)) {
		if (preg_match("/^text_(.*)/", $var)) {
			$outname = preg_replace("/^text_(.*)/", "$1.txt", $var);
			$outfile = "$thumb_dir/$outname";

			if (strlen($value) > 0) {
				// save to the work directory
				$fp = fopen($outfile, "w+");
				if ($fp) {
					fputs($fp, preg_replace("/\"/", "&quot;", $value));
					fflush($fp);
					fclose($fp);
				} else {
					die("error writing to $outfile");
				}
			} else {
				// remove old blurbfile if it exists
				if (is_file($outfile)) {
					unlink($outfile);
				}
			}
		}
	}

	$index_loc = preg_replace("/\/\//", "/", dirname(getenv("SCRIPT_NAME")) . "/$indexlink/$subdir");

	$pagenum = get_current_page();
	if ($pagenum > 1) 
	   $index_loc .= "?page=$pagenum";

	header("Location: $index_loc");

} else if (!$login_ok) {
	// show login screen
?>
<html>
<head>
<title><?php print $subdir ?> : login</title>
<link rel="stylesheet" type="text/css" href="<?php print $work_loc ?>/style.css">
</head>
<body>

<form method="post" action="<?php print getenv('SCRIPT_NAME') . "/$subdir" ?>">
<?php
$pagenum = get_current_page();
if ($pagenum > 1)
   print "<input type=hidden name=page value=$pagenum>";
?>

<table width="50%" cellspacing=1 cellpadding=5 align=center>

<tr>
  <td colspan=2 align=center><font class="header">log in to edit the thumbnail page<br>at <?php print dirname(getenv('SCRIPT_NAME')) . $subdir ?></font></td>
</tr>

<tr>
<?php
if ($failed_login) {
	print "<td colspan=2 align=center><font class=warning>bad username/password</font></td>\n";
} else {
	print "<td colspan=2 align=center>&nbsp;</td>\n";
}
?>
</tr>

<tr>
  <td align=right>username:</td>
  <td><input type="text" name="form_user" value=""></td>
</tr>
<tr>
  <td align=right>password:</td>
  <td><input type="password" name="form_pass" value=""></td>
</tr>
<tr>
<tr>
  <td></td>
  <td><input type="submit" value="login"></td>
</tr>
</table>
</form>

</body>
</html>

<?php
} else {
	// show edit blurbs page
?>
<html>
<head>
<title><?php print dirname(getenv('SCRIPT_NAME')) . $subdir . " : edit" ?></title>
<link rel="stylesheet" type="text/css" href="<?php print $work_loc ?>/style.css">
</head>
<body>

<center>

<form method="post" action="<?php print getenv('SCRIPT_NAME') . "/$subdir" ?>">
<input type="hidden" name="process_blurbs" value="1">
<?php
$pagenum = get_current_page();
if ($pagenum > 1)
	print "<input type=hidden name=page value=$pagenum>";
?>

<table width="100%" cellspacing=1 cellpadding=5 align=center>

<tr>
  <td colspan=3 align=center><font class="header">edit <?php print dirname(getenv('SCRIPT_NAME')) . $subdir ?></font></td>
</tr>

<!-- blurb for the page itself -->
<tr>
<td></td>
<td align=right>page description</td>
<td><input type="text" size=50 name="<?php print $page_blurb_var ?>" value="<?php print $page_blurb ?>"</td>
</tr>

<tr><td colspan=3><hr></td></tr>

<!-- file/dir blurbs -->
<?php
$return = get_entries();

if (count($return[0]) < 1) {
   print "<tr><td colspan=3 align=center>(no files to edit)</td></tr>";
} else {
  foreach ($return[0] as $edit) {
?>
<tr>
<td><img <?php print $edit->thumb_html_dims ?> src="<? print $edit->thumb_loc ?>" alt="<?php print $pic->name ?>"></td>

<td align=right><?php print $edit->name ?></td>
<td><input type="text" size=50 name="<?php print $edit->blurb_var ?>" value="<?php print $edit->blurb ?>"</td>
</tr>
<?php 
	} 
}
?>

<tr>
  <td></td><td></td><td><input type=submit value="save"></td>
</tr>
</table>
</form>
</body>
</html>
<?php
}
?>
