<?php
/*
 * view.php - display an image in a nice frame, optionally with a
 * short description, if the edit.php page is being used.  this file
 * is not strictly necessary.  if you want to link to the raw
 * image from the index page, don't bother copying this into the gallery
 * directory.
 *
 * part of the gallery six package:  http://muted.org/gallerysix
 *
 * Copyright (C) 2001  seth ladygo
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: view.php,v 1.8 2002/05/01 23:41:30 alx Exp $
 */

// possible names for the index page.
$indexpages = array("index.php", "index.php3");

$thisdir = dirname(getenv("SCRIPT_FILENAME"));

do {
	$val = current($indexpages);
	if (is_file("$thisdir/$val")) {
		$indexpage = $val;
		break;
	}
} while (next($indexpages));

// load in config info from the index page.
include("$indexpage");

$return = get_entries(basename(getenv("PATH_INFO")));
$entry = $return[0][0];

$backlink = preg_replace("/\/\//", "/", "$base_loc/$indexlink/$subdir");

$pagenum = get_current_page();
if ($pagenum > 1)
	$backlink .= "?page=$pagenum";

?>

<html>
<head><title><?php print $entry->name ?></title>
<link rel="stylesheet" type="text/css" href="<?php print $work_loc ?>/style.css">
</head>
<body>

<table align=center cellspacing=1 cellpadding=5 width="100%">

<?php if ($show_filename) { ?>
<tr>
  <td align=center><h2><?php print $entry->name ?></h2></td>
</tr>
<?php } ?>

<tr>
  <td align=center><a href="<?php print $backlink ?>"><image border="<?php print $border ?>" src="<?php print $entry->loc ?>" alt="<?php print $entry->name ?>"></a></td>
</tr>

<?php if (strlen($entry->blurb) > 0) { ?>
<tr>
  <td align=center><font class="caption"><?php print $entry->blurb ?></font></td>
</tr>
<?php } ?>

<tr>
  <td align=center><a href="<?php print $backlink ?>">(back)</a></td>
</tr>

</table>
</body>
</html>
